diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/visualizer/bindings/modulegen__gcc_LP64.py ns-3.35/src/visualizer/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/visualizer/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/visualizer/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
@@ -424,18 +424,18 @@
     ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
     module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
     module.add_container('std::map< std::string, ns3::LogComponent * >', ('std::string', 'ns3::LogComponent *'), container_type='map')
-    module.add_container('std::set< ns3::TypeId >', 'ns3::TypeId', container_type='set')
-    module.add_container('std::vector< ns3::PyViz::RxPacketSample >', 'ns3::PyViz::RxPacketSample', container_type='vector')
-    module.add_container('std::vector< ns3::PyViz::TxPacketSample >', 'ns3::PyViz::TxPacketSample', container_type='vector')
-    module.add_container('std::vector< ns3::PyViz::PacketSample >', 'ns3::PyViz::PacketSample', container_type='vector')
     module.add_container('std::vector< std::string >', 'std::string', container_type='vector')
     module.add_container('std::vector< ns3::PyViz::TransmissionSample >', 'ns3::PyViz::TransmissionSample', container_type='vector')
     module.add_container('ns3::PyViz::TransmissionSampleList', 'ns3::PyViz::TransmissionSample', container_type='vector')
     module.add_container('std::vector< ns3::PyViz::PacketDropSample >', 'ns3::PyViz::PacketDropSample', container_type='vector')
     module.add_container('ns3::PyViz::PacketDropSampleList', 'ns3::PyViz::PacketDropSample', container_type='vector')
+    module.add_container('std::vector< ns3::PyViz::RxPacketSample >', 'ns3::PyViz::RxPacketSample', container_type='vector')
+    module.add_container('std::vector< ns3::PyViz::TxPacketSample >', 'ns3::PyViz::TxPacketSample', container_type='vector')
+    module.add_container('std::vector< ns3::PyViz::PacketSample >', 'ns3::PyViz::PacketSample', container_type='vector')
     module.add_container('std::set< unsigned int >', 'unsigned int', container_type='set')
     module.add_container('std::vector< ns3::PyViz::NetDeviceStatistics >', 'ns3::PyViz::NetDeviceStatistics', container_type='vector')
     module.add_container('std::vector< ns3::PyViz::NodeStatistics >', 'ns3::PyViz::NodeStatistics', container_type='vector')
+    module.add_container('std::set< ns3::TypeId >', 'ns3::TypeId', container_type='set')
     module.add_container('std::vector< ns3::Ipv6Address >', 'ns3::Ipv6Address', container_type='vector')
     module.add_container('std::map< unsigned int, unsigned int >', ('unsigned int', 'unsigned int'), container_type='map')
     typehandlers.add_type_alias('void ( * ) ( std::ostream & )', 'ns3::TimePrinter')
@@ -1491,11 +1491,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1568,6 +1563,11 @@
     cls.add_constructor([param('ns3::Ipv4Address', 'local'), param('ns3::Ipv4Mask', 'mask')])
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4InterfaceAddress const & o) [constructor]
     cls.add_constructor([param('ns3::Ipv4InterfaceAddress const &', 'o')])
+    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetAddress() const [member function]
+    cls.add_method('GetAddress', 
+                   'ns3::Ipv4Address', 
+                   [], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetBroadcast() const [member function]
     cls.add_method('GetBroadcast', 
                    'ns3::Ipv4Address', 
@@ -1588,11 +1588,20 @@
                    'ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsInSameSubnet(ns3::Ipv4Address const b) const [member function]
+    cls.add_method('IsInSameSubnet', 
+                   'bool', 
+                   [param('ns3::Ipv4Address const', 'b')], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsSecondary() const [member function]
     cls.add_method('IsSecondary', 
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetAddress(ns3::Ipv4Address address) [member function]
+    cls.add_method('SetAddress', 
+                   'void', 
+                   [param('ns3::Ipv4Address', 'address')])
     ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetBroadcast(ns3::Ipv4Address broadcast) [member function]
     cls.add_method('SetBroadcast', 
                    'void', 
@@ -1661,11 +1670,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1782,11 +1786,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1979,11 +1978,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wave/helper/wifi-80211p-helper.cc ns-3.35/src/wave/helper/wifi-80211p-helper.cc
--- ns-3.34/src/wave/helper/wifi-80211p-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wave/helper/wifi-80211p-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -63,20 +63,6 @@
     }
 }
 
-// NS_DEPRECATED_3_32
-void
-Wifi80211pHelper::SetStandard (enum WifiPhyStandard standard)
-{
-  if ((standard == WIFI_PHY_STANDARD_80211a) || (standard == WIFI_PHY_STANDARD_80211_10MHZ))
-    {
-      WifiHelper::SetStandard (WIFI_STANDARD_80211p);
-    }
-  else
-    {
-      NS_FATAL_ERROR ("802.11p only use 802.11 standard with 10MHz or 20MHz");
-    }
-}
-
 void
 Wifi80211pHelper::EnableLogComponents (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wave/helper/wifi-80211p-helper.h ns-3.35/src/wave/helper/wifi-80211p-helper.h
--- ns-3.34/src/wave/helper/wifi-80211p-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wave/helper/wifi-80211p-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -61,16 +61,6 @@
   virtual void SetStandard (enum WifiStandard standard);
 
   /**
-   * \param standard the phy standard to configure during installation
-   *
-   * Users can only configure 802.11p with 10MHz or 5 MHz channel bandwidth.
-   * The default 802.11p standard uses 10MHz.
-   * \deprecated This method will go away in a future release of ns-3.
-   */
-  NS_DEPRECATED_3_32
-  virtual void SetStandard (WifiPhyStandard standard);
-
-  /**
    * \param phy the PHY helper to create PHY objects
    * \param macHelper the MAC helper to create MAC objects
    * \param c the set of nodes on which a wifi device must be created
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wave/model/ocb-wifi-mac.cc ns-3.35/src/wave/model/ocb-wifi-mac.cc
--- ns-3.34/src/wave/model/ocb-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wave/model/ocb-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
@@ -365,6 +365,9 @@
       dcf->SetMaxCw (cwmax);
       dcf->SetAifsn (aifsn);
       break;
+    case AC_BEACON:
+      // done by ApWifiMac
+      break;
     case AC_UNDEF:
       NS_FATAL_ERROR ("I don't know what to do with this");
       break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wave/model/wave-frame-exchange-manager.cc ns-3.35/src/wave/model/wave-frame-exchange-manager.cc
--- ns-3.34/src/wave/model/wave-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wave/model/wave-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -133,7 +133,7 @@
     }
 
   m_dcf->NotifyChannelAccessed ();
-  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIteratorPairs ().front ().it;
+  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIterator ();
   NS_ASSERT (mpdu != 0);
 
   // assign a sequence number if this is not a fragment nor a retransmission
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/athstats-helper.h ns-3.35/src/wifi/helper/athstats-helper.h
--- ns-3.34/src/wifi/helper/athstats-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/athstats-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -22,6 +22,7 @@
 #define ATHSTATS_HELPER_H
 
 #include "ns3/wifi-phy-state.h"
+#include "ns3/wifi-phy-common.h"
 
 namespace ns3 {
 
@@ -30,6 +31,7 @@
 class NetDeviceContainer;
 class Packet;
 class Mac48Address;
+class WifiMode;
 
 /**
  * @brief create AthstatsWifiTraceSink instances and connect them to wifi devices
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/spectrum-wifi-helper.cc ns-3.35/src/wifi/helper/spectrum-wifi-helper.cc
--- ns-3.34/src/wifi/helper/spectrum-wifi-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/spectrum-wifi-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -61,13 +61,13 @@
   phy->SetErrorRateModel (error);
   if (m_frameCaptureModel.IsTypeIdSet ())
     {
-      Ptr<FrameCaptureModel> capture = m_frameCaptureModel.Create<FrameCaptureModel> ();
-      phy->SetFrameCaptureModel (capture);
+      auto frameCapture = m_frameCaptureModel.Create<FrameCaptureModel> ();
+      phy->SetFrameCaptureModel (frameCapture);
     }
   if (m_preambleDetectionModel.IsTypeIdSet ())
     {
-      Ptr<PreambleDetectionModel> capture = m_preambleDetectionModel.Create<PreambleDetectionModel> ();
-      phy->SetPreambleDetectionModel (capture);
+      auto preambleDetection = m_preambleDetectionModel.Create<PreambleDetectionModel> ();
+      phy->SetPreambleDetectionModel (preambleDetection);
     }
   phy->SetChannel (m_channel);
   phy->SetDevice (device);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/wifi-helper.cc ns-3.35/src/wifi/helper/wifi-helper.cc
--- ns-3.34/src/wifi/helper/wifi-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/wifi-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -769,37 +769,6 @@
   m_standard = standard;
 }
 
-// NS_DEPRECATED_3_32
-void
-WifiHelper::SetStandard (WifiPhyStandard standard)
-{
-  switch (standard)
-    {
-    case WIFI_PHY_STANDARD_80211a:
-      m_standard = WIFI_STANDARD_80211a;
-      return;
-    case WIFI_PHY_STANDARD_80211b:
-      m_standard = WIFI_STANDARD_80211b;
-      return;
-    case WIFI_PHY_STANDARD_80211g:
-      m_standard = WIFI_STANDARD_80211g;
-      return;
-    // remove the next value from WifiPhyStandard when deprecation ends
-    case WIFI_PHY_STANDARD_80211n_2_4GHZ:
-      m_standard = WIFI_STANDARD_80211n_2_4GHZ;
-      return;
-    // remove the next value from WifiPhyStandard when deprecation ends
-    case WIFI_PHY_STANDARD_80211n_5GHZ:
-      m_standard = WIFI_STANDARD_80211n_5GHZ;
-      return;
-    case WIFI_PHY_STANDARD_80211ac:
-      m_standard = WIFI_STANDARD_80211ac;
-      return;
-    default:
-      NS_FATAL_ERROR ("Unsupported value of WifiPhyStandard");
-    }
-}
-
 void
 WifiHelper::SetSelectQueueCallback (SelectQueueCallback f)
 {
@@ -839,11 +808,11 @@
           device->SetHeConfiguration (heConfiguration);
         }
       Ptr<WifiRemoteStationManager> manager = m_stationManager.Create<WifiRemoteStationManager> ();
-      Ptr<WifiMac> mac = macHelper.Create (device, m_standard);
       Ptr<WifiPhy> phy = phyHelper.Create (node, device);
       phy->ConfigureStandardAndBand (it->second.phyStandard, it->second.phyBand);
-      device->SetMac (mac);
       device->SetPhy (phy);
+      Ptr<WifiMac> mac = macHelper.Create (device, m_standard);
+      device->SetMac (mac);
       device->SetRemoteStationManager (manager);
       node->AddDevice (device);
       if ((it->second.phyStandard >= WIFI_PHY_STANDARD_80211ax) && (m_obssPdAlgorithm.IsTypeIdSet ()))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/wifi-helper.h ns-3.35/src/wifi/helper/wifi-helper.h
--- ns-3.34/src/wifi/helper/wifi-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/wifi-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -475,33 +475,6 @@
   virtual void SetStandard (WifiStandard standard);
 
   /**
-   * \param standard the PHY standard to configure during installation
-   *
-   * This method sets standards-compliant defaults for WifiMac
-   * parameters such as SIFS time, slot time, timeout values, etc.,
-   * based on the standard selected.  It results in
-   * WifiMac::ConfigureStandard(standard) being called on each
-   * installed MAC object.
-   *
-   * The default standard of 802.11a will be applied if SetStandard()
-   * is not called.
-   *
-   * Note that WifiMac::ConfigureStandard () will overwrite certain
-   * defaults in the attribute system, so if a user wants to manipulate
-   * any default values affected by ConfigureStandard() while using this
-   * helper, the user should use a post-install configuration such as
-   * Config::Set() on any objects that this helper creates, such as:
-   * \code
-   * Config::Set ("/NodeList/0/DeviceList/0/$ns3::WifiNetDevice/Mac/Slot", TimeValue (MicroSeconds (slot)));
-   * \endcode
-   * \deprecated This method will go away in future release of ns-3.
-   *
-   * \sa Config::Set
-   */
-  NS_DEPRECATED_3_32
-  virtual void SetStandard (WifiPhyStandard standard);
-
-  /**
    * Helper to enable all WifiNetDevice log components with one statement
    */
   static void EnableLogComponents (void);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/wifi-mac-helper.h ns-3.35/src/wifi/helper/wifi-mac-helper.h
--- ns-3.34/src/wifi/helper/wifi-mac-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/wifi-mac-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -35,7 +35,7 @@
  * This class can create MACs of type ns3::ApWifiMac, ns3::StaWifiMac and ns3::AdhocWifiMac.
  * Its purpose is to allow a WifiHelper to configure and install WifiMac objects on a collection
  * of nodes. The WifiMac objects themselves are mainly composed of TxMiddle, RxMiddle, ChannelAccessManager,
- * MacLow, WifiRemoteStationManager, MpduAggregator and MsduAggregartor objects, so this helper
+ * FrameExchangeManager, WifiRemoteStationManager, MpduAggregator and MsduAggregartor objects, so this helper
  * offers the opportunity to configure attribute values away from their default values, on a
  * per-NodeContainer basis. By default, it creates an Adhoc MAC layer without QoS. Typically,
  * it is used to set type and attribute values, then hand this object over to the WifiHelper that
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/helper/yans-wifi-helper.cc ns-3.35/src/wifi/helper/yans-wifi-helper.cc
--- ns-3.34/src/wifi/helper/yans-wifi-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/helper/yans-wifi-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -151,13 +151,13 @@
   phy->SetErrorRateModel (error);
   if (m_frameCaptureModel.IsTypeIdSet ())
     {
-      Ptr<FrameCaptureModel> capture = m_frameCaptureModel.Create<FrameCaptureModel> ();
-      phy->SetFrameCaptureModel (capture);
+      auto frameCapture = m_frameCaptureModel.Create<FrameCaptureModel> ();
+      phy->SetFrameCaptureModel (frameCapture);
     }
   if (m_preambleDetectionModel.IsTypeIdSet ())
     {
-      Ptr<PreambleDetectionModel> capture = m_preambleDetectionModel.Create<PreambleDetectionModel> ();
-      phy->SetPreambleDetectionModel (capture);
+      auto preambleDetection = m_preambleDetectionModel.Create<PreambleDetectionModel> ();
+      phy->SetPreambleDetectionModel (preambleDetection);
     }
   phy->SetChannel (m_channel);
   phy->SetDevice (device);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/ap-wifi-mac.cc ns-3.35/src/wifi/model/ap-wifi-mac.cc
--- ns-3.34/src/wifi/model/ap-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/ap-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
@@ -35,6 +35,7 @@
 #include "amsdu-subframe-header.h"
 #include "wifi-phy.h"
 #include "wifi-net-device.h"
+#include "wifi-mac-queue.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/he-configuration.h"
 
@@ -103,7 +104,8 @@
     m_shortPreambleEnabled (false)
 {
   NS_LOG_FUNCTION (this);
-  m_beaconTxop = CreateObject<Txop> ();
+  m_beaconTxop = CreateObject<Txop> (CreateObject<WifiMacQueue> (AC_BEACON));
+  m_beaconTxop->SetWifiMac (this);
   m_beaconTxop->SetAifsn (1);
   m_beaconTxop->SetMinCw (0);
   m_beaconTxop->SetMaxCw (0);
@@ -118,7 +120,6 @@
 {
   NS_LOG_FUNCTION (this);
   m_staList.clear ();
-  m_addressIdMap.clear ();
 }
 
 void
@@ -142,6 +143,16 @@
   RegularWifiMac::SetBssid (address);
 }
 
+Ptr<WifiMacQueue>
+ApWifiMac::GetTxopQueue (AcIndex ac) const
+{
+  if (ac == AC_BEACON)
+    {
+      return m_beaconTxop->GetWifiMacQueue ();
+    }
+  return RegularWifiMac::GetTxopQueue (ac);
+}
+
 void
 ApWifiMac::SetBeaconGeneration (bool enable)
 {
@@ -165,14 +176,6 @@
 }
 
 void
-ApWifiMac::SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager)
-{
-  NS_LOG_FUNCTION (this << stationManager);
-  m_beaconTxop->SetWifiRemoteStationManager (stationManager);
-  RegularWifiMac::SetWifiRemoteStationManager (stationManager);
-}
-
-void
 ApWifiMac::SetLinkUpCallback (Callback<void> linkUp)
 {
   NS_LOG_FUNCTION (this << &linkUp);
@@ -513,6 +516,60 @@
   return edcaParameters;
 }
 
+MuEdcaParameterSet
+ApWifiMac::GetMuEdcaParameterSet (void) const
+{
+  NS_LOG_FUNCTION (this);
+  MuEdcaParameterSet muEdcaParameters;
+  if (GetHeSupported ())
+    {
+      Ptr<HeConfiguration> heConfiguration = GetHeConfiguration ();
+      NS_ASSERT (heConfiguration != 0);
+
+      muEdcaParameters.SetQosInfo (0);
+
+      UintegerValue uintegerValue;
+      TimeValue timeValue;
+
+      heConfiguration->GetAttribute ("MuBeAifsn", uintegerValue);
+      muEdcaParameters.SetMuAifsn (AC_BE, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuBeCwMin", uintegerValue);
+      muEdcaParameters.SetMuCwMin (AC_BE, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuBeCwMax", uintegerValue);
+      muEdcaParameters.SetMuCwMax (AC_BE, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("BeMuEdcaTimer", timeValue);
+      muEdcaParameters.SetMuEdcaTimer (AC_BE, timeValue.Get ());
+
+      heConfiguration->GetAttribute ("MuBkAifsn", uintegerValue);
+      muEdcaParameters.SetMuAifsn (AC_BK, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuBkCwMin", uintegerValue);
+      muEdcaParameters.SetMuCwMin (AC_BK, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuBkCwMax", uintegerValue);
+      muEdcaParameters.SetMuCwMax (AC_BK, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("BkMuEdcaTimer", timeValue);
+      muEdcaParameters.SetMuEdcaTimer (AC_BK, timeValue.Get ());
+
+      heConfiguration->GetAttribute ("MuViAifsn", uintegerValue);
+      muEdcaParameters.SetMuAifsn (AC_VI, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuViCwMin", uintegerValue);
+      muEdcaParameters.SetMuCwMin (AC_VI, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuViCwMax", uintegerValue);
+      muEdcaParameters.SetMuCwMax (AC_VI, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("ViMuEdcaTimer", timeValue);
+      muEdcaParameters.SetMuEdcaTimer (AC_VI, timeValue.Get ());
+
+      heConfiguration->GetAttribute ("MuVoAifsn", uintegerValue);
+      muEdcaParameters.SetMuAifsn (AC_VO, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuVoCwMin", uintegerValue);
+      muEdcaParameters.SetMuCwMin (AC_VO, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("MuVoCwMax", uintegerValue);
+      muEdcaParameters.SetMuCwMax (AC_VO, uintegerValue.Get ());
+      heConfiguration->GetAttribute ("VoMuEdcaTimer", timeValue);
+      muEdcaParameters.SetMuEdcaTimer (AC_VO, timeValue.Get ());
+    }
+  return muEdcaParameters;
+}
+
 HtOperation
 ApWifiMac::GetHtOperation (void) const
 {
@@ -717,6 +774,7 @@
     {
       probe.SetHeCapabilities (GetHeCapabilities ());
       probe.SetHeOperation (GetHeOperation ());
+      probe.SetMuEdcaParameterSet (GetMuEdcaParameterSet ());
     }
   packet->AddHeader (probe);
 
@@ -763,7 +821,7 @@
           aid = GetNextAssociationId ();
           m_staList.insert (std::make_pair (aid, to));
           m_assocLogger (aid, to);
-          m_addressIdMap.insert (std::make_pair (to, aid));
+          m_stationManager->SetAssociationId (to, aid);
           if (m_stationManager->GetDsssSupported (to) && !m_stationManager->GetErpOfdmSupported (to))
             {
               m_numNonErpStations++;
@@ -807,6 +865,7 @@
     {
       assoc.SetHeCapabilities (GetHeCapabilities ());
       assoc.SetHeOperation (GetHeOperation ());
+      assoc.SetMuEdcaParameterSet (GetMuEdcaParameterSet ());
     }
   packet->AddHeader (assoc);
 
@@ -863,6 +922,7 @@
     {
       beacon.SetHeCapabilities (GetHeCapabilities ());
       beacon.SetHeOperation (GetHeOperation ());
+      beacon.SetMuEdcaParameterSet (GetMuEdcaParameterSet ());
     }
   packet->AddHeader (beacon);
 
@@ -1294,7 +1354,6 @@
                     {
                       m_staList.erase (it);
                       m_deAssocLogger (it->first, it->second);
-                      m_addressIdMap.erase (from);
                       if (m_stationManager->GetDsssSupported (from) && !m_stationManager->GetErpOfdmSupported (from))
                         {
                           m_numNonErpStations--;
@@ -1399,13 +1458,7 @@
 uint16_t
 ApWifiMac::GetAssociationId (Mac48Address addr) const
 {
-  auto it = m_addressIdMap.find (addr);
-
-  if (it == m_addressIdMap.end ())
-    {
-      return SU_STA_ID;
-    }
-  return it->second;
+  return m_stationManager->GetAssociationId (addr);
 }
 
 uint8_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/ap-wifi-mac.h ns-3.35/src/wifi/model/ap-wifi-mac.h
--- ns-3.34/src/wifi/model/ap-wifi-mac.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/ap-wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
@@ -33,6 +33,7 @@
 class DsssParameterSet;
 class ErpInformation;
 class EdcaParameterSet;
+class MuEdcaParameterSet;
 class HtOperation;
 class VhtOperation;
 class HeOperation;
@@ -57,12 +58,12 @@
   ApWifiMac ();
   virtual ~ApWifiMac ();
 
-  void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager) override;
   void SetLinkUpCallback (Callback<void> linkUp) override;
   void Enqueue (Ptr<Packet> packet, Mac48Address to) override;
   void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from) override;
   bool SupportsSendFrom (void) const override;
   void SetAddress (Mac48Address address) override;
+  Ptr<WifiMacQueue> GetTxopQueue (AcIndex ac) const override;
 
   /**
    * \param interval the interval between two beacon transmissions.
@@ -233,6 +234,12 @@
    */
   EdcaParameterSet GetEdcaParameterSet (void) const;
   /**
+   * Return the MU EDCA Parameter Set of the current AP.
+   *
+   * \return the MU EDCA Parameter Set that we support
+   */
+  MuEdcaParameterSet GetMuEdcaParameterSet (void) const;
+  /**
    * Return the HT operation of the current AP.
    *
    * \return the HT operation that we support
@@ -307,8 +314,6 @@
   Ptr<UniformRandomVariable> m_beaconJitter; //!< UniformRandomVariable used to randomize the time of the first beacon
   bool m_enableBeaconJitter;                 //!< Flag whether the first beacon should be generated at random time
   std::map<uint16_t, Mac48Address> m_staList; //!< Map of all stations currently associated to the AP with their association ID
-  /// Maps MAC addresses of associated stations to their association ID
-  std::unordered_map<Mac48Address, uint16_t, WifiAddressHash> m_addressIdMap;
   uint16_t m_numNonErpStations;              //!< Number of non-ERP stations currently associated to the AP
   uint16_t m_numNonHtStations;               //!< Number of non-HT stations currently associated to the AP
   bool m_shortSlotTimeEnabled;               //!< Flag whether short slot time is enabled within the BSS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/block-ack-agreement.h ns-3.35/src/wifi/model/block-ack-agreement.h
--- ns-3.34/src/wifi/model/block-ack-agreement.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/block-ack-agreement.h	2021-10-01 13:26:48.000000000 -0700
@@ -32,8 +32,6 @@
  */
 class BlockAckAgreement
 {
-  /// Provide access to MacLow class
-  friend class MacLow;
   friend class HtFrameExchangeManager;
 
 public:
